﻿local timer = 0;
local timer2 = 0.9;
local timer3 = 1;
local timer4 = 1;
local inneresfeuer = GetSpellInfo(10952);

InnerFireHelperDB = {
	["Aufladungen"] = 10;
	["AufladungsMeldung"] = true;
	["EineMinuteMeldung"] = true;
	["SchwindenMeldung"] = true;
	["ZeigeFrame"] = true;
};


INNERFIREHELPER_SCHWINDET = " fade."
INNERFIREHELPER_AUFLADUNGEN_A = "Inner Fire: ";
INNERFIREHELPER_AUFLADUNGEN_E = " charges left.";
INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Inner Fire: 1 minute left.";
INNERFIREHELPER_OPTIONS_MINUTE_H = "Show warning at 1 minute left";
INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Show charges warning";
INNERFIREHELPER_OTIONS_SCHWINDET_H = "Show fade warning";
INNERFIREHELPER_OTIONS_FRAME_H = "Show Inner Fire Helper MiniBar";
INNERFIREHELPER_OTIONS_BUTTON_S = "Show InnerFire Icon when the buff is expired";
INNERFIREHELPER_OTIONS_AUFlADUNGEN = "How many charges to show warnig?";

if ( GetLocale() == "deDE" ) then
	INNERFIREHELPER_SCHWINDET = " schwindet."
	INNERFIREHELPER_OPTIONS_TEXTFARBE_BUTTON = "Setze Farbe";
	INNERFIREHELPER_AUFLADUNGEN_A = "Inneres Feuer: ";
	INNERFIREHELPER_AUFLADUNGEN_E = " Aufladungen verbleibend.";
	INNERFIREHELPER_AUFLADUNGEN_MINUTE = "Inneres Feuer: 1 Minute verbleibend.";
	INNERFIREHELPER_OPTIONS_MINUTE_H = "Zeige Warnung bei 1 Minute verbleibend";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN_H = "Zeige aufladungs Warnung";
	INNERFIREHELPER_OTIONS_SCHWINDET_H = "Zeige schwinden Warnung";
	INNERFIREHELPER_OTIONS_FRAME_H = "Zeige Inner Fire Helper MiniBar";
	INNERFIREHELPER_OTIONS_BUTTON_S = "Zeige InneresFeuer Icon wenn Buff abgelaufen";
	INNERFIREHELPER_OTIONS_AUFlADUNGEN = "Wieviele Aufladungen verbleibend bis zur Warnung?";
end 

local frame = CreateFrame("FRAME","InnerFireHelper",UIParent)
	frame:SetWidth(200)
	frame:SetHeight(20)
	frame:SetPoint("CENTER",UIParent)
	--frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
   --                                         edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
   --                                         edgeSize = 16, 
   --                                         insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:SetResizable(false)
	frame:RegisterForDrag("LeftButton")
	frame:RegisterForDrag("LeftButton", "RightButton")
	frame:SetScript("OnMouseDown", function()
		if (IsAltKeyDown()) then
			this:StartMoving()
		end;
	end)
	frame:SetScript("OnMouseUp", frame.StopMovingOrSizing) 
	frame:SetScript("OnUpdate", function()
		if InnerFireHelperDB["ZeigeFrame"] == true then
			InnerFireHelper:Show();
		else
			InnerFireHelper:Hide();
		end
		if InnerFireHelperDB["ShowIcon"] == true then
			InnerFireHelperIconFrame:Show();
		else
			InnerFireHelperIconFrame:Hide();
		end;
		local inneresfeuer = GetSpellInfo(10952);
		for i=1,40 do
			local buffname,_,_,buffcount,_,dur,x2 = UnitBuff("player",i);
				if buffname == inneresfeuer then
					local x = -1*(GetTime()-x2);
					local xzeit = math.floor(x/60);
					local minu = math.floor(x / 60);
					local seku = format("%.0f", mod(x, 60));
					InnerFireHelperText:SetTextColor(1.0, 1.0, 1.0, 1.0);
					InnerFireHelperText:SetText(inneresfeuer.."("..buffcount..") - "..minu.."."..seku);
					InnerFireHelperStatus:SetValue(x);
					InnerFireHelperIconFrame:Hide();
					if minu < 1 then
						InnerFireHelperText:SetTextColor(1.0, 0.0, 0.0, 1.0);
					end
					if minu == 0 and InnerFireHelperDB["EineMinuteMeldung"] == true and timer4 == 1 then
							InnerFireHelper_SetMitteText(INNERFIREHELPER_AUFLADUNGEN_MINUTE,"","")
							timer4 =0;
					end
					if minu ~= 0 then
						timer4 = 1;
					end
					if buffcount == InnerFireHelperDB["Aufladungen"] then
						InnerFireHelperText:SetTextColor(1.0, 0.0, 0.0, 1.0);
						if InnerFireHelperDB["AufladungsMeldung"] == true and timer3 == 1 then
							InnerFireHelper_SetMitteText(INNERFIREHELPER_AUFLADUNGEN_A,INNERFIREHELPER_AUFLADUNGEN_E,InnerFireHelperDB["Aufladungen"]);
							timer3 = 0;
						end
					end
					if buffcount ~= InnerFireHelperDB["Aufladungen"] then
						timer3 = 1;
					end
				end
		end
	end)
	
local InneresFeuerText = frame:CreateFontString("InnerFireHelperText","OVERLAY","GameFontNormal")
	InneresFeuerText:SetPoint("TOPLEFT", frame, "TOPLEFT", 22, 0)
	InneresFeuerText:SetText(inneresfeuer.."(0) - 0.0");
	InneresFeuerText:SetHeight(20)
	InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);

local InneresFeuerIcon = frame:CreateTexture("InnerFireHelperIcon","OVERLAY")
	InneresFeuerIcon:SetPoint("TOPLEFT", frame, "TOPLEFT")
	InneresFeuerIcon:SetTexture("Interface\\Icons\\spell_holy_innerfire")
	InneresFeuerIcon:SetHeight(20)
	InneresFeuerIcon:SetWidth(20)

local b=CreateFrame("STATUSBAR","InnerFireHelperStatus",frame,"TextStatusBar")
b:SetFrameStrata("BACKGROUND")
b:SetWidth(180)
b:SetHeight(20)
b:SetPoint("TOPLEFT", frame, "TOPLEFT", 19, 0)
b:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar","BACKGROUND")
b:SetMinMaxValues(0, 600)
b:SetValue(0)
b:SetStatusBarColor(1.0, 0.0, 1.0, 1.0)

local iconframe = CreateFrame("FRAME","InnerFireHelperIconFrame",UIParent)
	iconframe:SetWidth(32)
	iconframe:SetHeight(32)
	iconframe:SetPoint("CENTER",UIParent)
	iconframe:SetMovable(true)
	iconframe:EnableMouse(true)
	iconframe:SetResizable(false)
	iconframe:RegisterForDrag("LeftButton")
	iconframe:RegisterForDrag("LeftButton", "RightButton")
	iconframe:SetScript("OnMouseDown", function()
		if (IsAltKeyDown()) then
			this:StartMoving()
		end;
	end)
	iconframe:SetScript("OnMouseUp", iconframe.StopMovingOrSizing) 
	iconframe:SetScript("OnUpdate", function()
	end)

local InneresFeuerIcon2 = iconframe:CreateTexture("InnerFireHelperIcon2","OVERLAY")
	InneresFeuerIcon2:SetPoint("TOPLEFT", iconframe, "TOPLEFT")
	InneresFeuerIcon2:SetTexture("Interface\\Icons\\spell_holy_innerfire")
	InneresFeuerIcon2:SetHeight(32)
	InneresFeuerIcon2:SetWidth(32)	

 local frame2 = CreateFrame("FRAME","InnerFireHelperMitte",UIParent)
	frame2:SetWidth(500)
	frame2:SetHeight(100)
	frame2:SetPoint("CENTER",UIParent)
	frame2:RegisterEvent("COMBAT_LOG_EVENT")
	frame2:RegisterEvent("VARIABLES_LOADED")
	frame2:RegisterEvent("PLAYER_DEAD")
	frame2:SetScript("OnEvent", function()
		local inneresfeuer = GetSpellInfo(10952);
		if(arg2 == "SPELL_AURA_REMOVED" and arg10 == inneresfeuer) or (event == "PLAYER_DEAD") then
			InnerFireHelper_SetMitteText(inneresfeuer,INNERFIREHELPER_SCHWINDET,"");
			InneresFeuerText:SetText(inneresfeuer.."(0) - 0.0");
			InneresFeuerText:SetTextColor(1.0, 0.0, 0.0, 1.0);
			b:SetValue(0);
			if InnerFireHelperDB["ShowIcon"] == true then
				InnerFireHelperIconFrame:Show();
			else
				InnerFireHelperIconFrame:Hide();
			end;
		end
		if event == "VARIABLES_LOADED" then 
			if (not InnerFireHelperDB["ShowIcon"]) then InnerFireHelperDB["ShowIcon"] = false end;
		end
	end)
	frame2:SetScript("OnUpdate", function()
			InnerFireHelper_SetMitteTextUpdate()
	end)
	
local InneresFeuerText2 = frame2:CreateFontString("InnerFireHelperText2","OVERLAY","GameFontNormal")
	InneresFeuerText2:SetFontObject("BossEmoteNormalHuge")
	InneresFeuerText2:SetPoint("TOP", frame2, "CENTER")
	InneresFeuerText2:SetTextColor(1.0, 0.0, 0.0, 1.0);
	InneresFeuerText2:SetText(" ")
	

 function InnerFireHelper_SetMitteText(text, text2,text3)
		InneresFeuerText2:SetText(text..text3..text2);
		timer = 0;
		timer2 = 0.9;
 end
 
 function InnerFireHelper_SetMitteTextUpdate()
	timer = timer + (1/60)*2;
	if(timer > 5) then
		timer2 = timer2 - 0.1;
		InneresFeuerText2:SetTextColor(1.0, 0.0, 0.0, timer2);
			if timer2 < 0.1 then
				InneresFeuerText2:SetText(" ");
				InneresFeuerText2:SetTextColor(1.0, 0.0, 0.0, 1.0);
			end
	end
 end
 
 -- OPTIONS FUNC
 function InnerFireHelper_Close()
 	local text = edit1:GetNumber();
	InnerFireHelperDB["Aufladungen"]=text;
 end


-- OPTIONS

local panel = CreateFrame( "Frame", "InnerFireHelperPanel", UIParent );
	panel.name = "InnerFireHelper";
	panel.okay = function (self) InnerFireHelper_Close(); end;
 
local OptionUberschrift = panel:CreateFontString(nil,"HIGH","GameFontNormal")
	OptionUberschrift:SetPoint("CENTER", panel, "TOP", 0, -10)
	OptionUberschrift:SetText("InnerFireHelper")
	
local Check4 = CreateFrame("CheckButton", "check4", panel, "UICheckButtonTemplate") 
	Check4:SetPoint("LEFT", panel, "TOPLEFT", 5, -30)
	Check4:SetWidth(25)
	Check4:SetHeight(25)
	Check4:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_FRAME_H);
		if InnerFireHelperDB["ZeigeFrame"] == true then
			this:SetChecked(1);
		end
	end)
	Check4:SetScript("OnClick", function()
		if InnerFireHelperDB["ZeigeFrame"] == true then
			InnerFireHelperDB["ZeigeFrame"] = false;
			InnerFireHelper:Hide();
		else
			InnerFireHelperDB["ZeigeFrame"] = true;
			InnerFireHelper:Show();
		end
	end)

local Check1 = CreateFrame("CheckButton", "check1", panel, "UICheckButtonTemplate") 
	Check1:SetPoint("LEFT", panel, "TOPLEFT", 5, -60)
	Check1:SetWidth(25)
	Check1:SetHeight(25)
	Check1:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OPTIONS_MINUTE_H);
		if InnerFireHelperDB["EineMinuteMeldung"] == true then
			this:SetChecked(1);
		end
	end)
	Check1:SetScript("OnClick", function()
		if InnerFireHelperDB["EineMinuteMeldung"] == true then
			InnerFireHelperDB["EineMinuteMeldung"] = false;
			
		else
			InnerFireHelperDB["EineMinuteMeldung"] = true;
		end
	end)

local Check2 = CreateFrame("CheckButton", "check2", panel, "UICheckButtonTemplate") 
	Check2:SetPoint("LEFT", panel, "TOPLEFT", 5, -80)
	Check2:SetWidth(25)
	Check2:SetHeight(25)
	Check2:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_AUFlADUNGEN_H);
		if InnerFireHelperDB["AufladungsMeldung"] == true then
			this:SetChecked(1);
		end
	end)
	Check2:SetScript("OnClick", function()
		if InnerFireHelperDB["AufladungsMeldung"] == true then
			InnerFireHelperDB["AufladungsMeldung"] = false;
		else
			InnerFireHelperDB["AufladungsMeldung"] = true;
		end
	end)

local Check3 = CreateFrame("CheckButton", "check3", panel, "UICheckButtonTemplate") 
	Check3:SetPoint("LEFT", panel, "TOPLEFT", 5, -100)
	Check3:SetWidth(25)
	Check3:SetHeight(25)
	Check3:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_SCHWINDET_H);
		if InnerFireHelperDB["SchwindenMeldung"] == true then
			this:SetChecked(1);
		end
	end)
	Check3:SetScript("OnClick", function()
		if InnerFireHelperDB["SchwindenMeldung"] == true then
			InnerFireHelperDB["SchwindenMeldung"] = false;
		else
			InnerFireHelperDB["SchwindenMeldung"] = true;
		end
	end)	
	
local Check5 = CreateFrame("CheckButton", "check5", panel, "UICheckButtonTemplate") 
	Check5:SetPoint("LEFT", panel, "TOPLEFT", 5, -120)
	Check5:SetWidth(25)
	Check5:SetHeight(25)
	Check5:SetScript("OnUpdate", function()
		getglobal(this:GetName().."Text"):SetText(INNERFIREHELPER_OTIONS_BUTTON_S);
		if InnerFireHelperDB["ShowIcon"] == true then
			this:SetChecked(1);
		end
	end)
	Check5:SetScript("OnClick", function()
		if InnerFireHelperDB["ShowIcon"] == true then
			InnerFireHelperDB["ShowIcon"] = false;
		else
			InnerFireHelperDB["ShowIcon"] = true;
		end
	end)
	
local Edit1 = CreateFrame("EditBox", "edit1", panel, "InputBoxTemplate") 
	Edit1:SetPoint("LEFT", panel, "TOPLEFT", 15, -170)
	Edit1:SetWidth(32)
	Edit1:SetHeight(32)
	Edit1:SetAutoFocus(false)
	Edit1:SetTextInsets(0, 8, 0, 0)
	Edit1:SetNumeric(true)
	Edit1:SetMaxLetters(2)
	Edit1:SetScript("OnEnterPressed", function()
		this:ClearFocus();
		local text = this:GetNumber();
		InnerFireHelperDB["Aufladungen"]=text;
	end)
	Edit1:SetScript("OnShow", function()
		this:SetNumber(InnerFireHelperDB["Aufladungen"]);
	end)
	
	
local Opt1 = panel:CreateFontString("InnerFireHelperOpt1","OVERLAY","GameFontNormal")
	Opt1:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -140)
	Opt1:SetHeight(20)
	Opt1:SetText(INNERFIREHELPER_OTIONS_AUFlADUNGEN)

local Name = panel:CreateFontString("InnerFireHelperOpt1","OVERLAY","GameFontNormalSmall")
	Name:SetPoint("TOPLEFT", panel, "TOPLEFT", 220, -405)
	Name:SetHeight(20)
	Name:SetText("by Calí @ EU-Nera'thor PvP (Horde)")


InterfaceOptions_AddCategory(panel);